#include <iostream>
#include "tree.h"
#include <string>
#include "util_graphviz.h"
#include "util_tree.h"
#include "util_tree.cpp"
#include "util.h"
#include "util.cpp"
#include <map>
#include <vector>
#include <sstream>
#include <stack>

using namespace std;
using namespace aed;


#define m_sl_it map<string,list<string> >::iterator
#define m_sl map<string,list<string> >
#define sl list<string>
#define sl_it list<string>::iterator
#define mp(s1,s2) make_pair(s1,s2)

/* Auxiliar functions */
// searching function for AOO tree (returns an iterator to node position)
typename tree <string>::iterator findTree(tree <string> &A, string buscar, typename tree <string>::iterator it) { 
	typename tree<string>::iterator aux = A.end();
	if (it == A.end()) {
		return aux;
	}
	if (*it == buscar) return it;
	typename tree<string>::iterator hijo = it.lchild();
	while (hijo != A.end()) {
		aux = findTree(A,buscar,hijo);
		if (aux != A.end())
			return aux;
		++hijo;
	}
	return A.end();
}
typename tree <string>::iterator findTree(tree <string> &A, string buscar) {
	if (A.empty()) {
		typename tree<string>::iterator rta = A.end();
		return rta;
	}
	return findTree(A,buscar,A.begin());
}

// auxiliar list comparsion function
bool compareList(list <string> &L1, list <string> &L2) {
	if (L1.size() != L2.size()) return false;
	list <string>::iterator it1,it2;
	it1 = L1.begin();
	it2 = L2.begin();
	while (it1 != L1.end()) {
		if (*it1 != *it2) return false;
		it1++; it2++;
	}
	return true;
}

// auxiliar function
stack<int> s2s(string s){
	stack<int> pila;
	stringstream ss;
	ss<<s;
	int aux;
	while(ss>>aux){
		pila.push(aux);
	}
	return pila;
}

/* test cases generator */
// function that generates an oriented tree
void genTree (tree <string> &T) {
	tree <string>::iterator it;
	it = T.begin();
	it = T.insert(it, "Matusalen");
	it = it.lchild();
	it = T.insert(it,"Norberto");
	it = T.insert(it++,"Inocencio");
	it = T.insert(it++,"Wilfredo");
	
	it = findTree(T,"Inocencio");
	it = it.lchild();
	T.insert(it, "Teresa");
	
	it = findTree(T,"Wilfredo");
	it = it.lchild();
	it = T.insert(it,"Juana");
	it = it.lchild();
	it = T.insert(it,"Paola");
	it = it.lchild();
	it = T.insert(it,"Facundo");
	it = T.insert(it++,"Nicolás");
	
	it = findTree(T,"Wilfredo");
	it = it.lchild();
	it++;
	it = T.insert(it,"Alberto");
	it = it.lchild();
	it = T.insert(it,"Soledad");
	it = T.insert(it++,"Enrique");
	it = T.insert(it++,"Mauricio");
	
	it = findTree(T,"Norberto");
	it = it.lchild();
	it = T.insert(it, "Delia");
	it = it.lchild();
	it = T.insert(it,"Susana");
	it = T.insert(it++,"Marcelo");
	it = T.insert(it++,"Guillermo");
	it = T.insert(it++,"Marisa");
	it = T.insert(it++,"Lorena");
	
	it = findTree(T,"Susana");
	it = it.lchild();
	it = T.insert(it,"Victoria");
	it = T.insert(it++,"Agustín");
	it = T.insert(it++,"Julieta");
	it = T.insert(it++,"Camila");
	
	it = findTree(T,"Marcelo");
	it = it.lchild();
	it = T.insert(it,"Florencia");
	it = T.insert(it++,"Maira");
	it = T.insert(it++,"Agustina");
	it = T.insert(it++,"Ezequiel");
	
	it = findTree(T,"Maira");
	it = it.lchild();
	it = T.insert(it,"Ludmila");
	it = T.insert(it++,"Valentin");
	it = T.insert(it++,"Mia");
	it = T.insert(it++,"Marcos");
	
	it = findTree(T,"Enrique");
	it = it.lchild();
	it = T.insert(it,"Mackenna");
	it = T.insert(it++,"Lautaro");
	it = T.insert(it++,"Paloma");
}

// countries map generator
void genMap (m_sl &m, m_sl &m2) {
	m["Francia"].push_back("Perpignan");
	m["Francia"].push_back("Toulouse");
	m["Francia"].push_back("Paris");
	m["Francia"].push_back("Mulhouse");
	m["Francia"].push_back("Lille");
	m["Francia"].push_back("Calais");
	m["Francia"].push_back("Lyon");
	
	m["Gran Bretaa"].push_back("Dover");
	m["Gran Bretaa"].push_back("Londres");
	
	m["Espaa"].push_back("San Sebastin");
	m["Espaa"].push_back("Barcelona");
	m["Espaa"].push_back("Madrid");
	m["Espaa"].push_back("Bilbao");
	
	m["Suiza"].push_back("Ginebra");
	m["Suiza"].push_back("Lucerna");
	m["Suiza"].push_back("Zurich");
	
	m["Alemania"].push_back("Freiburg");
	m["Alemania"].push_back("Dsseldorf");
	m["Alemania"].push_back("Frankfurt");
	m["Alemania"].push_back("Stuttgart");
	m["Alemania"].push_back("Mnich");
	
	m["Blgica"].push_back("Antwerp");
	m["Blgica"].push_back("Bruselas");
	
	m["Paises Bajos"].push_back("Eindhoven");
	m["Paises Bajos"].push_back("Rotterdam");
	
	m["Italia"].push_back("Trento");
	m["Italia"].push_back("Roma");
	m["Italia"].push_back("Torino");
	m["Italia"].push_back("Milan");
	
	m["Austria"].push_back("Innsbruck");
	m["Austria"].push_back("Vienna");
	
	m["Portugal"].push_back("Lisboa");
	
	
	vector<pair<string,string> > v;
	
	v.push_back(mp("Londres","Dover"));
	v.push_back(mp("Calais","Dover"));
	v.push_back(mp("Paris","Calais"));
	v.push_back(mp("Paris","Lille"));
	v.push_back(mp("Paris","Mulhouse"));
	v.push_back(mp("Paris","Perpignan"));
	v.push_back(mp("Paris","Lyon"));
	v.push_back(mp("Paris","Toulouse"));
	v.push_back(mp("San Sebastin","Toulouse"));
	v.push_back(mp("San Sebastin","Bilbao"));
	v.push_back(mp("Madrid","Bilbao"));
	v.push_back(mp("Madrid","Barcelona"));
	v.push_back(mp("Perpignan","Barcelona"));
	v.push_back(mp("Perpignan","Lyon"));
	v.push_back(mp("Torino","Lyon"));
	v.push_back(mp("Torino","Milan"));
	v.push_back(mp("Torino","Roma"));
	v.push_back(mp("Ginebra","Lyon"));
	v.push_back(mp("Ginebra","Lucerna"));
	v.push_back(mp("Zurich","Lucerna"));
	v.push_back(mp("Milan","Lucerna"));
	v.push_back(mp("Milan","Trento"));
	v.push_back(mp("Roma","Trento"));
	v.push_back(mp("Innsbruck","Trento"));
	v.push_back(mp("Innsbruck","Zurich"));
	v.push_back(mp("Innsbruck","Vienna"));
	v.push_back(mp("Innsbruck","Mnich"));
	v.push_back(mp("Milan","Roma"));
	v.push_back(mp("Mnich","Stuttgart"));
	v.push_back(mp("Frankfurt","Stuttgart"));
	v.push_back(mp("Frankfurt","Dsseldorf"));
	v.push_back(mp("Eindhoven","Dsseldorf"));
	v.push_back(mp("Eindhoven","Rotterdam"));
	v.push_back(mp("Eindhoven","Antwerp"));
	v.push_back(mp("Bruselas","Antwerp"));
	v.push_back(mp("Bruselas","Lille"));
	v.push_back(mp("Freiburg","Stuttgart"));
	v.push_back(mp("Freiburg","Mulhouse"));
	v.push_back(mp("Freiburg","Zurich"));
	v.push_back(mp("Mulhouse","Zurich"));
	v.push_back(mp("Lisboa","Bilbao"));
	v.push_back(mp("Lisboa","Madrid"));
	
	for(unsigned int i = 0 ; i < v.size(); i++){
		m2[v[i].first].push_back(v[i].second);
		m2[v[i].second].push_back(v[i].first);
	}
	
}

// vector of division trees generator (lisp notation)
void genDivTree (vector <string> &S) {
	S.push_back("( 49675 5 ( 25 5 )1987 ( 9935 5 1987 ) )");
	S.push_back("( 23674 2 7 ( 14 2 7 )19 ( 38 2 19 )89 ( 133 7 19 )( 178 2 89 )( 266 2 7 ( 14 2 7 )19 ( 38 2 19 )( 133 7 19 ) )( 623 7 89 )( 1246 2 7 ( 14 2 7 )89 ( 178 2 89 )( 623 7 89 ) )( 1691 19 89 )( 3382 2 19 ( 38 2 19 )89 ( 178 2 89 )( 1691 19 89 ) )( 11837 7 19 89 ( 133 7 19 )( 623 7 89 )( 1691 19 89 ) ) )");
	S.push_back("( 83391 3 7 11 19 ( 21 3 7 )( 33 3 11 )( 57 3 19 )( 77 7 11 )( 133 7 19 )( 209 11 19 )( 231 3 7 11 ( 21 3 7 )( 33 3 11 )( 77 7 11 ) )( 361 19 )( 399 3 7 19 ( 21 3 7 )( 57 3 19 )( 133 7 19 ) )( 627 3 11 19 ( 33 3 11 )( 57 3 19 )( 209 11 19 ) )( 1083 3 19 ( 57 3 19 )( 361 19 ) )( 1463 7 11 19 ( 77 7 11 )( 133 7 19 )( 209 11 19 ) )( 2527 7 19 ( 133 7 19 )( 361 19 ) )( 3971 11 19 ( 209 11 19 )( 361 19 ) )( 4389 3 7 11 19 ( 21 3 7 )( 33 3 11 )( 57 3 19 )( 77 7 11 )( 133 7 19 )( 209 11 19 )( 231 3 7 11 ( 21 3 7 )( 33 3 11 )( 77 7 11 ) )( 399 3 7 19 ( 21 3 7 )( 57 3 19 )( 133 7 19 ) )( 627 3 11 19 ( 33 3 11 )( 57 3 19 )( 209 11 19 ) )( 1463 7 11 19 ( 77 7 11 )( 133 7 19 )( 209 11 19 ) ) )( 7581 3 7 19 ( 21 3 7 )( 57 3 19 )( 133 7 19 )( 361 19 )( 399 3 7 19 ( 21 3 7 )( 57 3 19 )( 133 7 19 ) )( 1083 3 19 ( 57 3 19 )( 361 19 ) )( 2527 7 19 ( 133 7 19 )( 361 19 ) ) )( 11913 3 11 19 ( 33 3 11 )( 57 3 19 )( 209 11 19 )( 361 19 )( 627 3 11 19 ( 33 3 11 )( 57 3 19 )( 209 11 19 ) )( 1083 3 19 ( 57 3 19 )( 361 19 ) )( 3971 11 19 ( 209 11 19 )( 361 19 ) ) )( 27797 7 11 19 ( 77 7 11 )( 133 7 19 )( 209 11 19 )( 361 19 )( 1463 7 11 19 ( 77 7 11 )( 133 7 19 )( 209 11 19 ) )( 2527 7 19 ( 133 7 19 )( 361 19 ) )( 3971 11 19 ( 209 11 19 )( 361 19 ) ) ) )");
	S.push_back("( 31850 2 5 7 ( 10 2 5 )13 ( 14 2 7 )( 25 5 )( 26 2 13 )( 35 5 7 )( 49 7 )( 50 2 5 ( 10 2 5 )( 25 5 ) )( 65 5 13 )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 91 7 13 )( 98 2 7 ( 14 2 7 )( 49 7 ) )( 130 2 5 ( 10 2 5 )13 ( 26 2 13 )( 65 5 13 ) )( 175 5 7 ( 25 5 )( 35 5 7 ) )( 182 2 7 13 ( 14 2 7 )( 26 2 13 )( 91 7 13 ) )( 245 5 7 ( 35 5 7 )( 49 7 ) )( 325 5 13 ( 25 5 )( 65 5 13 ) )( 350 2 5 7 ( 10 2 5 )( 14 2 7 )( 25 5 )( 35 5 7 )( 50 2 5 ( 10 2 5 )( 25 5 ) )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 175 5 7 ( 25 5 )( 35 5 7 ) ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) )( 490 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 )( 49 7 )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 98 2 7 ( 14 2 7 )( 49 7 ) )( 245 5 7 ( 35 5 7 )( 49 7 ) ) )( 637 7 13 ( 49 7 )( 91 7 13 ) )( 650 2 5 ( 10 2 5 )13 ( 25 5 )( 26 2 13 )( 50 2 5 ( 10 2 5 )( 25 5 ) )( 65 5 13 )( 130 2 5 ( 10 2 5 )13 ( 26 2 13 )( 65 5 13 ) )( 325 5 13 ( 25 5 )( 65 5 13 ) ) )( 910 2 5 7 ( 10 2 5 )13 ( 14 2 7 )( 26 2 13 )( 35 5 7 )( 65 5 13 )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 91 7 13 )( 130 2 5 ( 10 2 5 )13 ( 26 2 13 )( 65 5 13 ) )( 182 2 7 13 ( 14 2 7 )( 26 2 13 )( 91 7 13 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) ) )( 1225 5 7 ( 25 5 )( 35 5 7 )( 49 7 )( 175 5 7 ( 25 5 )( 35 5 7 ) )( 245 5 7 ( 35 5 7 )( 49 7 ) ) )( 1274 2 7 13 ( 14 2 7 )( 26 2 13 )( 49 7 )( 91 7 13 )( 98 2 7 ( 14 2 7 )( 49 7 ) )( 182 2 7 13 ( 14 2 7 )( 26 2 13 )( 91 7 13 ) )( 637 7 13 ( 49 7 )( 91 7 13 ) ) )( 2275 5 7 13 ( 25 5 )( 35 5 7 )( 65 5 13 )( 91 7 13 )( 175 5 7 ( 25 5 )( 35 5 7 ) )( 325 5 13 ( 25 5 )( 65 5 13 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) ) )( 2450 2 5 7 ( 10 2 5 )( 14 2 7 )( 25 5 )( 35 5 7 )( 49 7 )( 50 2 5 ( 10 2 5 )( 25 5 ) )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 98 2 7 ( 14 2 7 )( 49 7 ) )( 175 5 7 ( 25 5 )( 35 5 7 ) )( 245 5 7 ( 35 5 7 )( 49 7 ) )( 350 2 5 7 ( 10 2 5 )( 14 2 7 )( 25 5 )( 35 5 7 )( 50 2 5 ( 10 2 5 )( 25 5 ) )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 175 5 7 ( 25 5 )( 35 5 7 ) ) )( 490 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 )( 49 7 )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 98 2 7 ( 14 2 7 )( 49 7 ) )( 245 5 7 ( 35 5 7 )( 49 7 ) ) )( 1225 5 7 ( 25 5 )( 35 5 7 )( 49 7 )( 175 5 7 ( 25 5 )( 35 5 7 ) )( 245 5 7 ( 35 5 7 )( 49 7 ) ) ) )( 3185 5 7 13 ( 35 5 7 )( 49 7 )( 65 5 13 )( 91 7 13 )( 245 5 7 ( 35 5 7 )( 49 7 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) )( 637 7 13 ( 49 7 )( 91 7 13 ) ) )( 4550 2 5 7 ( 10 2 5 )13 ( 14 2 7 )( 25 5 )( 26 2 13 )( 35 5 7 )( 50 2 5 ( 10 2 5 )( 25 5 ) )( 65 5 13 )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 91 7 13 )( 130 2 5 ( 10 2 5 )13 ( 26 2 13 )( 65 5 13 ) )( 175 5 7 ( 25 5 )( 35 5 7 ) )( 182 2 7 13 ( 14 2 7 )( 26 2 13 )( 91 7 13 ) )( 325 5 13 ( 25 5 )( 65 5 13 ) )( 350 2 5 7 ( 10 2 5 )( 14 2 7 )( 25 5 )( 35 5 7 )( 50 2 5 ( 10 2 5 )( 25 5 ) )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 175 5 7 ( 25 5 )( 35 5 7 ) ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) )( 650 2 5 ( 10 2 5 )13 ( 25 5 )( 26 2 13 )( 50 2 5 ( 10 2 5 )( 25 5 ) )( 65 5 13 )( 130 2 5 ( 10 2 5 )13 ( 26 2 13 )( 65 5 13 ) )( 325 5 13 ( 25 5 )( 65 5 13 ) ) )( 910 2 5 7 ( 10 2 5 )13 ( 14 2 7 )( 26 2 13 )( 35 5 7 )( 65 5 13 )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 91 7 13 )( 130 2 5 ( 10 2 5 )13 ( 26 2 13 )( 65 5 13 ) )( 182 2 7 13 ( 14 2 7 )( 26 2 13 )( 91 7 13 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) ) )( 2275 5 7 13 ( 25 5 )( 35 5 7 )( 65 5 13 )( 91 7 13 )( 175 5 7 ( 25 5 )( 35 5 7 ) )( 325 5 13 ( 25 5 )( 65 5 13 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) ) ) )( 6370 2 5 7 ( 10 2 5 )13 ( 14 2 7 )( 26 2 13 )( 35 5 7 )( 49 7 )( 65 5 13 )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 91 7 13 )( 98 2 7 ( 14 2 7 )( 49 7 ) )( 130 2 5 ( 10 2 5 )13 ( 26 2 13 )( 65 5 13 ) )( 182 2 7 13 ( 14 2 7 )( 26 2 13 )( 91 7 13 ) )( 245 5 7 ( 35 5 7 )( 49 7 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) )( 490 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 )( 49 7 )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 98 2 7 ( 14 2 7 )( 49 7 ) )( 245 5 7 ( 35 5 7 )( 49 7 ) ) )( 637 7 13 ( 49 7 )( 91 7 13 ) )( 910 2 5 7 ( 10 2 5 )13 ( 14 2 7 )( 26 2 13 )( 35 5 7 )( 65 5 13 )( 70 2 5 7 ( 10 2 5 )( 14 2 7 )( 35 5 7 ) )( 91 7 13 )( 130 2 5 ( 10 2 5 )13 ( 26 2 13 )( 65 5 13 ) )( 182 2 7 13 ( 14 2 7 )( 26 2 13 )( 91 7 13 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) ) )( 1274 2 7 13 ( 14 2 7 )( 26 2 13 )( 49 7 )( 91 7 13 )( 98 2 7 ( 14 2 7 )( 49 7 ) )( 182 2 7 13 ( 14 2 7 )( 26 2 13 )( 91 7 13 ) )( 637 7 13 ( 49 7 )( 91 7 13 ) ) )( 3185 5 7 13 ( 35 5 7 )( 49 7 )( 65 5 13 )( 91 7 13 )( 245 5 7 ( 35 5 7 )( 49 7 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) )( 637 7 13 ( 49 7 )( 91 7 13 ) ) ) )( 15925 5 7 13 ( 25 5 )( 35 5 7 )( 49 7 )( 65 5 13 )( 91 7 13 )( 175 5 7 ( 25 5 )( 35 5 7 ) )( 245 5 7 ( 35 5 7 )( 49 7 ) )( 325 5 13 ( 25 5 )( 65 5 13 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) )( 637 7 13 ( 49 7 )( 91 7 13 ) )( 1225 5 7 ( 25 5 )( 35 5 7 )( 49 7 )( 175 5 7 ( 25 5 )( 35 5 7 ) )( 245 5 7 ( 35 5 7 )( 49 7 ) ) )( 2275 5 7 13 ( 25 5 )( 35 5 7 )( 65 5 13 )( 91 7 13 )( 175 5 7 ( 25 5 )( 35 5 7 ) )( 325 5 13 ( 25 5 )( 65 5 13 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) ) )( 3185 5 7 13 ( 35 5 7 )( 49 7 )( 65 5 13 )( 91 7 13 )( 245 5 7 ( 35 5 7 )( 49 7 ) )( 455 5 7 13 ( 35 5 7 )( 65 5 13 )( 91 7 13 ) )( 637 7 13 ( 49 7 )( 91 7 13 ) ) ) ) )");
	S.push_back("( 93160 2 ( 4 2 )5 ( 8 2 ( 4 2 ) )( 10 2 5 )17 ( 20 2 ( 4 2 )5 ( 10 2 5 ) )( 34 2 17 )( 40 2 ( 4 2 )5 ( 8 2 ( 4 2 ) )( 10 2 5 )( 20 2 ( 4 2 )5 ( 10 2 5 ) ) )( 68 2 ( 4 2 )17 ( 34 2 17 ) )( 85 5 17 )( 136 2 ( 4 2 )( 8 2 ( 4 2 ) )17 ( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) ) )137 ( 170 2 5 ( 10 2 5 )17 ( 34 2 17 )( 85 5 17 ) )( 274 2 137 )( 340 2 ( 4 2 )5 ( 10 2 5 )17 ( 20 2 ( 4 2 )5 ( 10 2 5 ) )( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) )( 85 5 17 )( 170 2 5 ( 10 2 5 )17 ( 34 2 17 )( 85 5 17 ) ) )( 548 2 ( 4 2 )137 ( 274 2 137 ) )( 680 2 ( 4 2 )5 ( 8 2 ( 4 2 ) )( 10 2 5 )17 ( 20 2 ( 4 2 )5 ( 10 2 5 ) )( 34 2 17 )( 40 2 ( 4 2 )5 ( 8 2 ( 4 2 ) )( 10 2 5 )( 20 2 ( 4 2 )5 ( 10 2 5 ) ) )( 68 2 ( 4 2 )17 ( 34 2 17 ) )( 85 5 17 )( 136 2 ( 4 2 )( 8 2 ( 4 2 ) )17 ( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) ) )( 170 2 5 ( 10 2 5 )17 ( 34 2 17 )( 85 5 17 ) )( 340 2 ( 4 2 )5 ( 10 2 5 )17 ( 20 2 ( 4 2 )5 ( 10 2 5 ) )( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) )( 85 5 17 )( 170 2 5 ( 10 2 5 )17 ( 34 2 17 )( 85 5 17 ) ) ) )( 685 5 137 )( 1096 2 ( 4 2 )( 8 2 ( 4 2 ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) ) )( 1370 2 5 ( 10 2 5 )137 ( 274 2 137 )( 685 5 137 ) )( 2329 17 137 )( 2740 2 ( 4 2 )5 ( 10 2 5 )( 20 2 ( 4 2 )5 ( 10 2 5 ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) )( 685 5 137 )( 1370 2 5 ( 10 2 5 )137 ( 274 2 137 )( 685 5 137 ) ) )( 4658 2 17 ( 34 2 17 )137 ( 274 2 137 )( 2329 17 137 ) )( 5480 2 ( 4 2 )5 ( 8 2 ( 4 2 ) )( 10 2 5 )( 20 2 ( 4 2 )5 ( 10 2 5 ) )( 40 2 ( 4 2 )5 ( 8 2 ( 4 2 ) )( 10 2 5 )( 20 2 ( 4 2 )5 ( 10 2 5 ) ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) )( 685 5 137 )( 1096 2 ( 4 2 )( 8 2 ( 4 2 ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) ) )( 1370 2 5 ( 10 2 5 )137 ( 274 2 137 )( 685 5 137 ) )( 2740 2 ( 4 2 )5 ( 10 2 5 )( 20 2 ( 4 2 )5 ( 10 2 5 ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) )( 685 5 137 )( 1370 2 5 ( 10 2 5 )137 ( 274 2 137 )( 685 5 137 ) ) ) )( 9316 2 ( 4 2 )17 ( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) )( 2329 17 137 )( 4658 2 17 ( 34 2 17 )137 ( 274 2 137 )( 2329 17 137 ) ) )( 11645 5 17 ( 85 5 17 )137 ( 685 5 137 )( 2329 17 137 ) )( 18632 2 ( 4 2 )( 8 2 ( 4 2 ) )17 ( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) )( 136 2 ( 4 2 )( 8 2 ( 4 2 ) )17 ( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) )( 1096 2 ( 4 2 )( 8 2 ( 4 2 ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) ) )( 2329 17 137 )( 4658 2 17 ( 34 2 17 )137 ( 274 2 137 )( 2329 17 137 ) )( 9316 2 ( 4 2 )17 ( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) )( 2329 17 137 )( 4658 2 17 ( 34 2 17 )137 ( 274 2 137 )( 2329 17 137 ) ) ) )( 23290 2 5 ( 10 2 5 )17 ( 34 2 17 )( 85 5 17 )137 ( 170 2 5 ( 10 2 5 )17 ( 34 2 17 )( 85 5 17 ) )( 274 2 137 )( 685 5 137 )( 1370 2 5 ( 10 2 5 )137 ( 274 2 137 )( 685 5 137 ) )( 2329 17 137 )( 4658 2 17 ( 34 2 17 )137 ( 274 2 137 )( 2329 17 137 ) )( 11645 5 17 ( 85 5 17 )137 ( 685 5 137 )( 2329 17 137 ) ) )( 46580 2 ( 4 2 )5 ( 10 2 5 )17 ( 20 2 ( 4 2 )5 ( 10 2 5 ) )( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) )( 85 5 17 )137 ( 170 2 5 ( 10 2 5 )17 ( 34 2 17 )( 85 5 17 ) )( 274 2 137 )( 340 2 ( 4 2 )5 ( 10 2 5 )17 ( 20 2 ( 4 2 )5 ( 10 2 5 ) )( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) )( 85 5 17 )( 170 2 5 ( 10 2 5 )17 ( 34 2 17 )( 85 5 17 ) ) )( 548 2 ( 4 2 )137 ( 274 2 137 ) )( 685 5 137 )( 1370 2 5 ( 10 2 5 )137 ( 274 2 137 )( 685 5 137 ) )( 2329 17 137 )( 2740 2 ( 4 2 )5 ( 10 2 5 )( 20 2 ( 4 2 )5 ( 10 2 5 ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) )( 685 5 137 )( 1370 2 5 ( 10 2 5 )137 ( 274 2 137 )( 685 5 137 ) ) )( 4658 2 17 ( 34 2 17 )137 ( 274 2 137 )( 2329 17 137 ) )( 9316 2 ( 4 2 )17 ( 34 2 17 )( 68 2 ( 4 2 )17 ( 34 2 17 ) )137 ( 274 2 137 )( 548 2 ( 4 2 )137 ( 274 2 137 ) )( 2329 17 137 )( 4658 2 17 ( 34 2 17 )137 ( 274 2 137 )( 2329 17 137 ) ) )( 11645 5 17 ( 85 5 17 )137 ( 685 5 137 )( 2329 17 137 ) )( 23290 2 5 ( 10 2 5 )17 ( 34 2 17 )( 85 5 17 )137 ( 170 2 5 ( 10 2 5 )17 ( 34 2 17 )( 85 5 17 ) )( 274 2 137 )( 685 5 137 )( 1370 2 5 ( 10 2 5 )137 ( 274 2 137 )( 685 5 137 ) )( 2329 17 137 )( 4658 2 17 ( 34 2 17 )137 ( 274 2 137 )( 2329 17 137 ) )( 11645 5 17 ( 85 5 17 )137 ( 685 5 137 )( 2329 17 137 ) ) ) ) )");
	S.push_back("( 97260 2 3 ( 4 2 )5 ( 6 2 3 )( 10 2 5 )( 12 2 3 ( 4 2 )( 6 2 3 ) )( 15 3 5 )( 20 2 ( 4 2 )5 ( 10 2 5 ) )( 30 2 3 5 ( 6 2 3 )( 10 2 5 )( 15 3 5 ) )( 60 2 3 ( 4 2 )5 ( 6 2 3 )( 10 2 5 )( 12 2 3 ( 4 2 )( 6 2 3 ) )( 15 3 5 )( 20 2 ( 4 2 )5 ( 10 2 5 ) )( 30 2 3 5 ( 6 2 3 )( 10 2 5 )( 15 3 5 ) ) )1621 ( 3242 2 1621 )( 4863 3 1621 )( 6484 2 ( 4 2 )1621 ( 3242 2 1621 ) )( 8105 5 1621 )( 9726 2 3 ( 6 2 3 )1621 ( 3242 2 1621 )( 4863 3 1621 ) )( 16210 2 5 ( 10 2 5 )1621 ( 3242 2 1621 )( 8105 5 1621 ) )( 19452 2 3 ( 4 2 )( 6 2 3 )( 12 2 3 ( 4 2 )( 6 2 3 ) )1621 ( 3242 2 1621 )( 4863 3 1621 )( 6484 2 ( 4 2 )1621 ( 3242 2 1621 ) )( 9726 2 3 ( 6 2 3 )1621 ( 3242 2 1621 )( 4863 3 1621 ) ) )( 24315 3 5 ( 15 3 5 )1621 ( 4863 3 1621 )( 8105 5 1621 ) )( 32420 2 ( 4 2 )5 ( 10 2 5 )( 20 2 ( 4 2 )5 ( 10 2 5 ) )1621 ( 3242 2 1621 )( 6484 2 ( 4 2 )1621 ( 3242 2 1621 ) )( 8105 5 1621 )( 16210 2 5 ( 10 2 5 )1621 ( 3242 2 1621 )( 8105 5 1621 ) ) )( 48630 2 3 5 ( 6 2 3 )( 10 2 5 )( 15 3 5 )( 30 2 3 5 ( 6 2 3 )( 10 2 5 )( 15 3 5 ) )1621 ( 3242 2 1621 )( 4863 3 1621 )( 8105 5 1621 )( 9726 2 3 ( 6 2 3 )1621 ( 3242 2 1621 )( 4863 3 1621 ) )( 16210 2 5 ( 10 2 5 )1621 ( 3242 2 1621 )( 8105 5 1621 ) )( 24315 3 5 ( 15 3 5 )1621 ( 4863 3 1621 )( 8105 5 1621 ) ) ) )");
	S.push_back("( 20185 5 11 ( 55 5 11 )367 ( 1835 5 367 )( 4037 11 367 ) )");
	S.push_back("( 83838 2 3 ( 6 2 3 )89 157 ( 178 2 89 )( 267 3 89 )( 314 2 157 )( 471 3 157 )( 534 2 3 ( 6 2 3 )89 ( 178 2 89 )( 267 3 89 ) )( 942 2 3 ( 6 2 3 )157 ( 314 2 157 )( 471 3 157 ) )( 13973 89 157 )( 27946 2 89 157 ( 178 2 89 )( 314 2 157 )( 13973 89 157 ) )( 41919 3 89 157 ( 267 3 89 )( 471 3 157 )( 13973 89 157 ) ) )");
	S.push_back("( 19826 2 23 ( 46 2 23 )431 ( 862 2 431 )( 9913 23 431 ) )");
	S.push_back("( 25162 2 23 ( 46 2 23 )547 ( 1094 2 547 )( 12581 23 547 ) )");
}

// stack generator (exercise 4)
void genStack(vector <stack <int> > &V, vector <bool> &B) {
	V.push_back(s2s("1 8 7 3 2 8 2 9 9 2 8 2 3 7 8 1"));
	V.push_back(s2s("10 2 3 9 0 9 3 2 11"));
	V.push_back(s2s("9 8 7 9"));
	V.push_back(s2s("9 3 6 1 1 2 3 10 9 3 9 3 6 1 1 2 3 10 9 3 9"));
	V.push_back(s2s("10 2 1 10 10 2 1 10"));
	V.push_back(s2s("9 9 9"));
	bool BB[] = {1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0};
	vector<bool> BBB(BB,BB+sizeof(BB)/sizeof(bool));
	B=BBB;
	V.push_back(s2s("1632 8866 61736 74512 2681 83107 58104 46934 45565 89387 4832 31402 69029 17753 97746 89246 28103 71146 15329 22566 82196 79859 42510 64481 68609 98411 4111 10488 33761 71312 79632 51745 80177 57719 42608 82858 40825 17063 46143 2741 22802 67326 50494 91830 91830 50494 67326 22802 2741 46143 17063 40825 82858 42608 57719 80177 51745 79632 71312 33761 10488 4111 98411 68609 64481 42510 79859 82196 22566 15329 71146 28103 89246 97746 17753 69029 31402 4832 89387 45565 46934 58104 83107 2681 74512 61736 8866 1632"));
	V.push_back(s2s("48240 97427 13181 19385 12755 52098 17932 92614 94607 98764 77574 9369 2875 4413 59481 90538 396 27577 70714 58114 86537 69923 15290 3599 16065 34382 26400 83391 84876 34581 84820 33115 32007 14352 68851 61114 82801 3135 70079 77407 1898 47652 3127 21124 52064 78960 11661 52460 6536 98727 26925 93072 85001 58567 13023 17418 92948 55774 17160 94175 90355 1979 43641 38713 16331 12492 16178 99131 31978 86256 92890 33875 50259 12368 71351 2323 91327 83011 0 83011 91327 2323 71351 12368 50259 33875 92890 86256 31978 99131 16178 12492 16331 38713 43641 1979 90355 94175 17160 55774 92948 17418 13023 58567 85001 93072 26925 98727 6536 52460 11661 78960 52064 21124 3127 47652 1898 77407 70079 3135 82801 61114 68851 14352 32007 33115 84820 34581 84876 83391 26400 34382 16065 3599 15290 69923 86537 58114 70714 27577 396 90538 59481 4413 2875 9369 77574 98764 94607 92614 17932 52098 12755 19385 13181 97427 48240"));
	V.push_back(s2s("14215 98089 98058 7286 83090 56624 36660 507 65924 92434 34018 60098 99140 35996 3739 54204 68678 32582 70382 84161 64559 72989 93402 14785 23248 5769 86135 25570 97096 85498 96703 11310 83586 11112 11112 83586 11310 96703 85498 97096 25570 86135 5769 23248 14785 93402 72989 64559 84161 70382 32582 68678 54204 3739 35996 99140 60098 34018 92434 65924 507 36660 56624 83090 7286 98058 98089 14215"));
	V.push_back(s2s("83027 84088 71607 99885 50011 64040 33902 10108 79531 69898 13846 33734 54927 62779 20467 39087 27337 93456 32488 42122 16703 38257 44608 58624 51704 30105 71678 79365 30043 82789 30663 13069 66876 2269 12954 33238 82660 46855 43346 78542 33104 73543 12276 88031 36322 32742 27117 0 27117 32742 36322 88031 12276 73543 33104 78542 43346 46855 82660 33238 12954 2269 66876 13069 30663 82789 30043 79365 71678 30105 51704 58624 44608 38257 16703 42122 32488 93456 27337 39087 20467 62779 54927 33734 13846 69898 79531 10108 33902 64040 50011 99885 71607 84088 83027"));
	V.push_back(s2s("42549 75957 38483 59251 30565 83091 34226 82268 29547 22255 22255 29547 82268 34226 83091 30565 59251 38483 75957 42549"));
	V.push_back(s2s("5989 21396 8646 89010 4623 27267 18315 37861 26278 81521 81206 4820 14625 71100 17095 2655 23773 66188 46123 3783 8737 38431 42265 84339 68995 41707 18565 51262 87606 57171 45597 63546 78566 54243 52555 83189 81509 87221 21049 7786 68742 18606 28957 83366 89705 46051 2372 29830 12239 64846 33612 37327 3277 92228 21665 72271 33935 56581 39885 21540 13752 85481 85085 92317 56075 53992 91857 53935 41212 12905 78073 9953 47862 7029 9670 53919 53080 12041 83748 81670 93239 17359 18996 96515 0 96515 18996 17359 93239 81670 83748 12041 53080 53919 9670 7029 47862 9953 78073 12905 41212 53935 91857 53992 56075 92317 85085 85481 13752 21540 39885 56581 33935 72271 21665 92228 3277 37327 33612 64846 12239 29830 2372 46051 89705 83366 28957 18606 68742 7786 21049 87221 81509 83189 52555 54243 78566 63546 45597 57171 87606 51262 18565 41707 68995 84339 42265 38431 8737 3783 46123 66188 23773 2655 17095 71100 14625 4820 81206 81521 26278 37861 18315 27267 4623 89010 8646 21396 59589"));
}


// evalClass ejercicio1
typedef string (*common_relative1) (tree<string>&,string,string);
void evaluar1 (common_relative1 F) {
	tree <string> T;
	genTree(T);
	int n=0;
	cout<< "[common_relative]\n";
	cout<<"Caso "<< n++ <<": "<< (F(T,"Facundo","Mia") == "Matusalen" ? "BIEN\n" : "MAL\n");
	cout<<"Caso "<< n++ <<": "<< (F(T,"Marcos","Ludmila") == "Maira" ? "BIEN\n" : "MAL\n");
	cout<<"Caso "<< n++ <<": "<< (F(T,"Julieta","Victoria") == "Susana" ? "BIEN\n" : "MAL\n");
	cout<<"Caso "<< n++ <<": "<< (F(T,"Mauricio","Lautaro") == "Alberto" ? "BIEN\n" : "MAL\n");
	cout<<"Caso "<< n++ <<": "<< (F(T,"Facundo","Lautaro") == "Wilfredo" ? "BIEN\n" : "MAL\n");
	cout<<"Caso "<< n++ <<": "<< (F(T,"Paloma","Lautaro") == "Enrique" ? "BIEN\n" : "MAL\n");
	cout<<"Caso "<< n++ <<": "<< (F(T,"Ludmila","Victoria") == "Delia" ? "BIEN\n" : "MAL\n");
	cout<<"Caso "<< n++ <<": "<< (F(T,"Marcelo","Maira") == "Marcelo" ? "BIEN\n" : "MAL\n");
	cout<<"Caso "<< n++ <<": "<< (F(T,"Mackenna","Victoria") == "Matusalen" ? "BIEN\n" : "MAL\n");
	cout<<"Caso "<< n++ <<": "<< (F(T,"Paloma","Soledad") == "Alberto" ? "BIEN\n" : "MAL\n");
}

// evalClass ejercicio2
typedef void (*div_tree1) (tree<int>&,int);
void evaluar2 (div_tree1 F) {
	vector <string> S;
	genDivTree(S);
	cout<< "\n[div_tree]\n";
	for (int n = 0; n<10; n++) {
		tree <int> T;
		char c; int d;
		stringstream ss;
		ss<<S[n];
		ss>>c;
		ss>>d;
		F(T,d);
		cout<<"Caso "<< n <<": "<< (tree2lisp(T) == S[n] ? "BIEN\n" : "MAL\n");
	}
}



// evalClass ejercicio3
typedef sl (*bordering_countries1) (m_sl&,m_sl&,string);
void evaluar3 (bordering_countries1 F) {
	m_sl m,m2;
	genMap(m,m2);
	list <string> aux;
	int n=0;
	cout<< "\n[bordering_countries]\n";
	cout<<"Caso "<< n++ <<": ";
	list <string> L = (F(m,m2,"Alemania"));
	aux.insert(aux.end(),"Austria");
	aux.insert(aux.end(),"Francia");
	aux.insert(aux.end(),"Paises Bajos");
	aux.insert(aux.end(),"Suiza");
	cout << (compareList(aux,L) ? "BIEN\n" : "MAL\n");
	aux.clear(); L.clear();
	
	cout<<"Caso "<< n++ <<": ";
	L = (F(m,m2,"Francia"));
	aux.insert(aux.end(),"Alemania");
	aux.insert(aux.end(),"Blgica");
	aux.insert(aux.end(),"Espaa");
	aux.insert(aux.end(),"Gran Bretaa");
	aux.insert(aux.end(),"Italia");
	aux.insert(aux.end(),"Suiza");
	cout << (compareList(aux,L) ? "BIEN\n" : "MAL\n");
	aux.clear(); L.clear();
	
	cout<<"Caso "<< n++ <<": ";
	L = (F(m,m2,"Suiza"));
	aux.insert(aux.end(),"Alemania");
	aux.insert(aux.end(),"Austria");
	aux.insert(aux.end(),"Francia");
	aux.insert(aux.end(),"Italia");
	cout << (compareList(aux,L) ? "BIEN\n" : "MAL\n");
	aux.clear(); L.clear();
	
	cout<<"Caso "<< n++ <<": ";
	L = (F(m,m2,"Austria"));
	aux.insert(aux.end(),"Alemania");
	aux.insert(aux.end(),"Italia");
	aux.insert(aux.end(),"Suiza");
	cout << (compareList(aux,L) ? "BIEN\n" : "MAL\n");
	aux.clear(); L.clear();
	
	cout<<"Caso "<< n++ <<": ";
	L = (F(m,m2,"Espaa"));
	aux.insert(aux.end(),"Francia");
	aux.insert(aux.end(),"Portugal");
	cout << (compareList(aux,L) ? "BIEN\n" : "MAL\n");
	aux.clear(); L.clear();
	
	cout<<"Caso "<< n++ <<": ";
	L = (F(m,m2,"Paises Bajos"));
	aux.insert(aux.end(),"Alemania");
	aux.insert(aux.end(),"Blgica");
	cout << (compareList(aux,L) ? "BIEN\n" : "MAL\n");
}



// evalClass ejercicio3
typedef bool (*is_palindrome1) (stack<int>&);
void evaluar4 (is_palindrome1 F) {
	cout<< "\n[is_palindrome]\n";
	vector <bool> V;
	vector <stack <int> > S;
	genStack(S,V);
	for (unsigned int i=0;i<S.size();i++) {
		cout<<"Caso "<< i <<": "<< (F(S[i]) == V[i] ? "BIEN\n" : "MAL\n");
	}
	cout<<"Verificar restricciones.\n";
}





